#include <bits/stdc++.h>

using namespace std;

#define ll long long
const int INF=1e9;
const ll LINF=1e18,MOD=1e9+7;
#define fi first
#define se second
#define pii pair<int,int>
#define mid ((l+r)/2)
#define sz(a) (int((a).size()))
#define all(a) a.begin(),a.end()
#define endl "\n"
#define pb push_back

void PRINT(int x) {cerr << x;}
void PRINT(ll x) {cerr << x;}
void PRINT(double x) {cerr << x;}
void PRINT(char x) {cerr << '\'' << x << '\'';}
void PRINT(string x) {cerr << '\"' << x << '\"';}
void PRINT(bool x) {cerr << (x ? "true" : "false");}

template<typename T,typename V>
void PRINT(pair<T,V>& x){
    cerr<<"{";
    PRINT(x.fi);
    cerr<<",";
    PRINT(x.se);
    cerr<<"}";
}
template<typename T>
void PRINT(T &x){
    int id=0;
    cerr<<"{";
    for(auto _i:x){
        cerr<<(id++ ? "," : "");
        PRINT(_i);
    }
    cerr<<"}";
}
void _PRINT(){
    cerr<<"]\n";
}
template<typename Head,typename... Tail>
void _PRINT(Head h,Tail... t){
    PRINT(h);
    if(sizeof...(t)) cerr<<", ";
    _PRINT(t...);
}

#ifndef ONLINE_JUDGE
#define Debug(x...) cerr<<"["<<#x<<"]=["; _PRINT(x)
#endif

int MaxBit(int x){
    for(int bit=30;bit>=0;bit--){
        if((x>>bit)&1) return bit;
    }
}

const int mxN=5001;

struct Node{
    vector<int> bits;
    int cnt;
    Node(){
        bits.resize(31);
        cnt=0;
    }
}seg[31][4*mxN];

void PRINT(Node x){
    cerr<<"{"<<x.cnt<<",";
    int id=0;
    cerr<<"{";
    for(auto _i:x.bits){
        cerr<<(id++ ? "," : "");
        PRINT(_i);
    }
    cerr<<"}";
}

vector<int> Ag;

Node Merge(Node& n1,Node n2){
    Node n=Node();
    for(int b=0;b<=30;b++){
        n.bits[b]=n1.bits[b]+n2.bits[b];
        n.cnt=n1.cnt+n2.cnt;
    }
    return n;
}

void Init(int node,int l,int r,int bit){
    if(l==r){
        if(MaxBit(Ag[l])==bit){
            for(int b=0;b<=30;b++){
                if((Ag[l]>>b)&1){
                    seg[bit][node].bits[b]++;
                }
            }
            seg[bit][node].cnt=1;
            //Debug(node,l,r,bit,seg[bit][node]);
        }
        return;
    }
    Init(2*node,l,mid,bit);
    Init(2*node+1,mid+1,r,bit);
    seg[bit][node]=Merge(seg[bit][2*node],seg[bit][2*node+1]);
    //Debug(node,l,r,bit,seg[bit][node]);
}

Node Query(int node,int l,int r,int L,int R,int bit){
    if(L<=l && r<=R) return seg[bit][node];
    Node ret=Node();
    if(L<=mid) ret=Merge(ret,Query(2*node,l,mid,L,R ,bit));
    if(R>mid) ret=Merge(ret,Query(2*node+1,mid+1,r,L,R,bit));
    return ret;
}

void Skloni(int node,int l,int r,int idx,int bit){
    if(l==r){
        seg[bit][node]=Node();
        return;
    }
    if(idx<=mid) Skloni(2*node,l,mid,idx,bit);
    else Skloni(2*node+1,mid+1,r,idx,bit);
    seg[bit][node]=Merge(seg[bit][2*node],seg[bit][2*node+1]);
}

void Update(int node,int l,int r,int idx,int x,int bit){
    if(l==r){
        for(int b=0;b<=30;b++){
            if((x>>b)&1){
                seg[bit][node].bits[b]++;
            }
        }
        seg[bit][node].cnt=1;
        Ag[l]=x;
        return;
    }
    if(idx<=mid) Update(2*node,l,mid,idx,x,bit);
    else Update(2*node+1,mid+1,r,idx,x,bit);
    seg[bit][node]=Merge(seg[bit][2*node],seg[bit][2*node+1]);
}

void Resi(int N, int *A, int Q, int *T, int *I, int *X, bool *O) {
    if(N>5000) exit(1);
    Ag.resize(N+1);
    for(int i=1;i<=N;i++){
        Ag[i]=A[i];
    }
    for(int b=0;b<=30;b++) Init(1,1,N,b);
    for(int i=1;i<=Q;i++){
        //Debug(i);
        if(T[i]==1){
            int idx=I[i];
            int x=X[i];
            Skloni(1,1,N,idx,MaxBit(Ag[idx]));
            Update(1,1,N,idx,x,MaxBit(x));
        }
        else{
            O[i]=true;
            int l=I[i];
            int r=I[i]+X[i]-1;
            vector<int> bit_sme(31,0);
            //Debug(l,r);
            for(int b=30;b>=0;b--){
                Node ret=Query(1,1,N,l,r,b);
                /*
                if(b==1 || b==0){
                    Debug(ret);
                    Debug(bit_sme);
                }
                */
                if(bit_sme[b]>30){}
                else if(ret.cnt<=(1<<bit_sme[b])){}
                else{
                    O[i]=false;
                    break;
                }
                for(int b1=b-1;b1>=0;b1--){
                    bit_sme[b1]+=ret.bits[b1];
                }
            }
        }
    }
}